Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# Ogre::ColourInterpolatorAffector Class Reference

`#include <OgreColourInterpolatorAffector.h>`

Inheritance diagram for Ogre::ColourInterpolatorAffector:

[legend]
List of all members.

## Public Types

enum | { MAX_STAGES = 6 }

## Public Methods

| ColourInterpolatorAffector ()
| Default constructor.
void | _affectParticles (ParticleSystem *pSystem, Real timeElapsed)
| See ParticleAffector.
void | setColourAdjust (size_t index, ColourValue colour)
ColourValue | getColourAdjust (size_t index) const
void | setTimeAdjust (size_t index, Real time)
Real | getTimeAdjust (size_t index) const
virtual void | _initParticle (Particle *pParticle)
| Method called to allow the affector to initialize all newly created particles in the system.
String | getType (void) const
| Returns the name of the type of affector.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.

## Static Public Methods

void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Static Public Attributes

CmdColourAdjust | msColourCmd [MAX_STAGES]
CmdTimeAdjust | msTimeCmd [MAX_STAGES]

## Protected Methods

void | addBaseParameters (void)
| Internal method for setting up the basic parameter definitions for a subclass.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.

## Protected Attributes

ColourValue | mColourAdj [MAX_STAGES]
Real | mTimeAdj [MAX_STAGES]
String | mType
| Name of the type of affector, MUST be initialised by subclasses.
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).

## Static Protected Attributes

ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Member Enumeration Documentation

anonymous enum

Enumeration values:

  MAX_STAGES |

Definition at line 42 of file OgreColourInterpolatorAffector.h.

## Constructor & Destructor Documentation

Ogre::ColourInterpolatorAffector::ColourInterpolatorAffector | ( |  | ) |

Default constructor.

Definition at line 38 of file OgreColourInterpolatorAffector.cpp.

References Ogre::ParamDictionary::addParameter(), Ogre::StringInterface::createParamDictionary(), Ogre::StringInterface::getParamDictionary(), MAX_STAGES, mColourAdj, Ogre::ColourInterpolatorAffector::CmdTimeAdjust::mIndex, Ogre::ColourInterpolatorAffector::CmdColourAdjust::mIndex, msColourCmd, msTimeCmd, mTimeAdj, Ogre::ParticleAffector::mType, Ogre::PT_COLOURVALUE, Ogre::PT_REAL, and Ogre::String.

## Member Function Documentation

void Ogre::ColourInterpolatorAffector::_affectParticles | ( | ParticleSystem * | pSystem,
|  | Real | timeElapsed
| ) | `[virtual]`

See ParticleAffector.

Implements Ogre::ParticleAffector.

Definition at line 73 of file OgreColourInterpolatorAffector.cpp.

References Ogre::ParticleSystem::_getIterator(), Ogre::ColourValue::a, Ogre::ColourValue::b, Ogre::ParticleIterator::end(), Ogre::ColourValue::g, Ogre::ParticleIterator::getNext(), MAX_STAGES, Ogre::Billboard::mColour, mColourAdj, mTimeAdj, Ogre::Particle::mTimeToLive, Ogre::Particle::mTotalTimeToLive, Ogre::ColourValue::r, and Ogre::Real.

virtual void Ogre::ParticleAffector::_initParticle | ( | Particle * | pParticle | ) | `[virtual, inherited]`

Method called to allow the affector to initialize all newly created particles in the system.

Remarks:
  This is where the affector gets the chance to initialize it's effects to the particles of a system. The affector is expected to initialize some or all of the particles in the system passed to it, depending on the affector's approach.

Parameters:

  pParticle | Pointer to a Particle to initialize.

Reimplemented in Ogre::ColourImageAffector, and Ogre::RotationAffector.

Definition at line 81 of file OgreParticleAffector.h.

void Ogre::ParticleAffector::addBaseParameters | ( | void |  | ) | `[protected, inherited]`

Internal method for setting up the basic parameter definitions for a subclass.

Remarks:
  Because StringInterface holds a dictionary of parameters per class, subclasses need to call this to ask the base class to add it's parameters to their dictionary as well. Can't do this in the constructor because that runs in a non-virtual context.

  The subclass must have called it's own createParamDictionary before calling this method.

Definition at line 68 of file OgreParticleAffector.h.

Referenced by Ogre::LinearForceAffector::LinearForceAffector().

void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. MaterialManager) initializes. Definition at line 53 of file OgreStringInterface.cpp. References Ogre::StringInterface::msDictionary.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 293 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

Referenced by Ogre::GuiElement::clone(), Ogre::GuiElement::copyFromTemplate(), Ogre::GuiContainer::copyFromTemplate(), and Ogre::ParticleSystem::operator=().

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 169 of file OgreStringInterface.h.

References Ogre::String.

Referenced by Ogre::ExternalTextureSource::addBaseParams(), Ogre::BorderButtonGuiElement::BorderButtonGuiElement(), Ogre::BorderPanelGuiElement::BorderPanelGuiElement(), Ogre::ButtonGuiElement::ButtonGuiElement(), Ogre::CgProgram::CgProgram(), Ogre::ColourFaderAffector::ColourFaderAffector(), Ogre::ColourFaderAffector2::ColourFaderAffector2(), Ogre::ColourImageAffector::ColourImageAffector(), ColourInterpolatorAffector(), Ogre::CursorGuiElement::CursorGuiElement(), Ogre::D3D9HLSLProgram::D3D9HLSLProgram(), Ogre::GLSLProgram::GLSLProgram(), Ogre::AreaEmitter::initDefaults(), Ogre::ParticleSystem::initParameters(), Ogre::LinearForceAffector::LinearForceAffector(), Ogre::ListGuiElement::ListGuiElement(), Ogre::PanelGuiElement::PanelGuiElement(), Ogre::PointEmitter::PointEmitter(), Ogre::PopupMenuGuiElement::PopupMenuGuiElement(), Ogre::RotationAffector::RotationAffector(), Ogre::ScaleAffector::ScaleAffector(), Ogre::ScrollBarGuiElement::ScrollBarGuiElement(), Ogre::TextAreaGuiElement::TextAreaGuiElement(), Ogre::TextBoxGuiElement::TextBoxGuiElement(), and Ogre::TTYGuiElement::TTYGuiElement().

ColourValue Ogre::ColourInterpolatorAffector::getColourAdjust | ( | size_t | index | ) | const

| Definition at line 117 of file OgreColourInterpolatorAffector.cpp. References mColourAdj. Referenced by Ogre::ColourInterpolatorAffector::CmdColourAdjust::doGet().

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

| Definition at line 206 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 193 of file OgreStringInterface.h.

Referenced by Ogre::TTYGuiElement::addBaseParameters(), Ogre::TextBoxGuiElement::addBaseParameters(), Ogre::TextAreaGuiElement::addBaseParameters(), Ogre::ScrollBarGuiElement::addBaseParameters(), Ogre::PopupMenuGuiElement::addBaseParameters(), Ogre::ParticleEmitter::addBaseParameters(), Ogre::PanelGuiElement::addBaseParameters(), Ogre::ListGuiElement::addBaseParameters(), Ogre::GuiElement::addBaseParameters(), Ogre::CursorGuiElement::addBaseParameters(), Ogre::ButtonGuiElement::addBaseParameters(), Ogre::BorderPanelGuiElement::addBaseParameters(), Ogre::BorderButtonGuiElement::addBaseParameters(), Ogre::ExternalTextureSource::addBaseParams(), Ogre::CgProgram::CgProgram(), Ogre::ColourFaderAffector::ColourFaderAffector(), Ogre::ColourFaderAffector2::ColourFaderAffector2(), Ogre::ColourImageAffector::ColourImageAffector(), ColourInterpolatorAffector(), Ogre::D3D9HLSLProgram::D3D9HLSLProgram(), Ogre::GLSLProgram::GLSLProgram(), Ogre::HollowEllipsoidEmitter::HollowEllipsoidEmitter(), Ogre::AreaEmitter::initDefaults(), Ogre::ParticleSystem::initParameters(), Ogre::LinearForceAffector::LinearForceAffector(), Ogre::RingEmitter::RingEmitter(), Ogre::RotationAffector::RotationAffector(), Ogre::ScaleAffector::ScaleAffector(), and Ogre::StringInterface::setParameter().

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 262 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), Ogre::ParamDictionary::getParamCommand(), and Ogre::String.

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

Definition at line 224 of file OgreStringInterface.h.

References Ogre::ParamDictionary::getParameters(), and Ogre::ParameterList.

Real Ogre::ColourInterpolatorAffector::getTimeAdjust | ( | size_t | index | ) | const

| Definition at line 129 of file OgreColourInterpolatorAffector.cpp. References mTimeAdj, and Ogre::Real. Referenced by Ogre::ColourInterpolatorAffector::CmdTimeAdjust::doGet().

String Ogre::ParticleAffector::getType | ( | void |  | ) | const`[inherited]`

Returns the name of the type of affector.

Remarks:
  This property is useful for determining the type of affector procedurally so another can be created.

Definition at line 100 of file OgreParticleAffector.h.

References Ogre::String.

Referenced by Ogre::ParticleSystemManager::_destroyAffector(), Ogre::ParticleSystem::operator=(), and Ogre::ParticleSystemManager::parseAffectorAttrib().

void Ogre::ColourInterpolatorAffector::setColourAdjust | ( | size_t | index,
|  | ColourValue | colour
| ) |

| Definition at line 112 of file OgreColourInterpolatorAffector.cpp. References mColourAdj.

bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Definition at line 33 of file OgreStringInterface.cpp.

References Ogre::ParamCommand::doSet(), Ogre::ParamDictionary::getParamCommand(), Ogre::StringInterface::getParamDictionary(), and Ogre::String.

Referenced by Ogre::StringInterface::copyParametersTo(), Ogre::Profiler::createContainer(), Ogre::Profiler::createTextArea(), Ogre::MaterialSerializer::finishProgramDefinition(), Ogre::ParticleSystemManager::parseAffectorAttrib(), Ogre::ParticleSystemManager::parseAttrib(), Ogre::OverlayManager::parseElementAttrib(), and Ogre::ParticleSystemManager::parseEmitterAttrib().

void Ogre::ColourInterpolatorAffector::setTimeAdjust | ( | size_t | index,
|  | Real | time
| ) |

| Definition at line 124 of file OgreColourInterpolatorAffector.cpp. References mTimeAdj, and Ogre::Real.

## Member Data Documentation

ColourValue Ogre::ColourInterpolatorAffector::mColourAdj[MAX_STAGES]`[protected]`

| Definition at line 84 of file OgreColourInterpolatorAffector.h. Referenced by _affectParticles(), ColourInterpolatorAffector(), getColourAdjust(), and setColourAdjust().

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

| Class name for this instance to be used as a lookup (must be initialised by subclasses). Definition at line 157 of file OgreStringInterface.h.

ColourInterpolatorAffector::CmdColourAdjust Ogre::ColourInterpolatorAffector::msColourCmd`[static]`

| Definition at line 34 of file OgreColourInterpolatorAffector.cpp. Referenced by ColourInterpolatorAffector().

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

| Dictionary of parameters. Definition at line 30 of file OgreStringInterface.cpp. Referenced by Ogre::StringInterface::cleanupDictionary().

ColourInterpolatorAffector::CmdTimeAdjust Ogre::ColourInterpolatorAffector::msTimeCmd`[static]`

| Definition at line 35 of file OgreColourInterpolatorAffector.cpp. Referenced by ColourInterpolatorAffector().

Real Ogre::ColourInterpolatorAffector::mTimeAdj[MAX_STAGES]`[protected]`

| Definition at line 85 of file OgreColourInterpolatorAffector.h. Referenced by _affectParticles(), ColourInterpolatorAffector(), getTimeAdjust(), and setTimeAdjust().

String Ogre::ParticleAffector::mType`[protected, inherited]`

Name of the type of affector, MUST be initialised by subclasses.

Definition at line 58 of file OgreParticleAffector.h.

Referenced by Ogre::ColourFaderAffector::ColourFaderAffector(), Ogre::ColourFaderAffector2::ColourFaderAffector2(), Ogre::ColourImageAffector::ColourImageAffector(), ColourInterpolatorAffector(), Ogre::LinearForceAffector::LinearForceAffector(), Ogre::RotationAffector::RotationAffector(), and Ogre::ScaleAffector::ScaleAffector().

The documentation for this class was generated from the following files:

- OgreColourInterpolatorAffector.h
- OgreColourInterpolatorAffector.cpp

Copyright © 2002-2003 by The OGRE Team
Last modified Sun Nov 28 19:49:49 2004